 INCLUDE asmtime.inc


 .code

getCPUstring PROC
    push rax
    push rbx
    push rcx
    push rdx
    push rdi
    lea  rdi, idString1
    mov  eax, 0
    CPUID
    mov[rdi],   ebx
    mov[rdi+4], edx
    mov[rdi+8], ecx
    mov ecx, 0
    mov[rdi+12], ecx
    pop rdi
    pop rdx
    pop rcx
    pop rbx
    pop rax
    ret
getCPUstring ENDP


getCPUDetails PROC
        push rax
        push rbx
        push rcx
        push rdx
        push rdi
        mov  eax, 1
        CPUID
        mov DWORD PTR eaxCode1, eax  ; Features Code
        mov DWORD PTR edxCode1, edx  ; family/model/stepping
        mov DWORD PTR ecxCode1, ecx 
        mov DWORD PTR ebxCode1, ebx 

        ; get specials
        mov eax,80000000h
        CPUID
        cmp eax,80000000h
        jc nomore
        mov eax, DWORD PTR intel1amd2
        cmp eax, 1
        jz intel
        cmp eax, 2
        jnz nomore
        mov eax,80000001h
        CPUID
        mov DWORD PTR ext81edx,edx
        mov eax,80000000h
        CPUID
        cmp eax,80000004h
        jc nomore                
        lea  rdi, idString2
        mov eax,80000002h
        CPUID
        mov[rdi],    eax
        mov[rdi+4],  ebx
        mov[rdi+8],  ecx
        mov[rdi+12], edx
        mov eax,80000003h
        CPUID
        mov[rdi+16], eax
        mov[rdi+20], ebx
        mov[rdi+24], ecx
        mov[rdi+28], edx
        mov eax,80000004h
        CPUID
        mov[rdi+32], eax
        mov[rdi+36], ebx
        mov[rdi+40], ecx
        mov[rdi+44], edx
        mov ecx, 0
        mov[rdi+48], ecx
        jmp nomore
     intel:
        mov eax,80000000h
        CPUID
        cmp eax,80000004h
        jc nomore                
        lea  rdi, idString2
        mov eax,80000002h
        CPUID
        mov[rdi],    eax
        mov[rdi+4],  ebx
        mov[rdi+8],  ecx
        mov[rdi+12], edx
        mov eax,80000003h
        CPUID
        mov[rdi+16], eax
        mov[rdi+20], ebx
        mov[rdi+24], ecx
        mov[rdi+28], edx
        mov eax,80000004h
        CPUID
        mov[rdi+32], eax
        mov[rdi+36], ebx
        mov[rdi+40], ecx
        mov[rdi+44], edx
        mov ecx, 0
        mov[rdi+48], ecx
     nomore:
        pop rdi
        pop rdx
        pop rcx
        pop rbx
        pop rax
        ret
getCPUDetails ENDP

calculateMHz PROC
        push rax
        push rdx
        mov DWORD PTR startCount, 0
        mov DWORD PTR endCount, 0
        call start_time
        RDTSC 
        mov DWORD PTR startCount, eax 
    timeloop:
        call end_time
        mov eax, DWORD PTR millisecs 
        cmp eax, DWORD PTR looptime
        jae      endloop
        mov edx, 1000
    mainloop:    
        dec     edx
        jne     mainloop
        RDTSC
        mov     DWORD PTR endCount, eax
        jmp     timeloop
    endloop:
        mov     eax, DWORD PTR endCount
        sub     eax, DWORD PTR startCount
        mov     DWORD PTR cycleCount, eax        
        pop rdx
        pop rax
        ret
calculateMHz ENDP

end


